package com.senocular.display
{
	import flash.display.BlendMode;
	import flash.events.Event;
	
	public class TransformToolScaleControl extends TransformToolInternalControl 
	{
	
		function TransformToolScaleControl( name: String, interactionMethod: Function, referenceName: String )
		{
			super( name, interactionMethod, referenceName );
			blendMode = BlendMode.NORMAL;
		}

		override public function draw( event: Event = null ): void 
		{
			super.draw();
			var size:Number  = _transformTool.controlSize;
			var size2:Number = size/2;
			
			graphics.clear( );

			graphics.beginFill( getStyle( "outlineFillColor", 0x000000 ), 0.0 );
			graphics.drawRect( -size2*2, -size2*2, size*2, size*2 );
			graphics.endFill( );

			graphics.lineStyle( 0, getStyle( "outlineStrokeColor", 0x000000 ), getStyle( "outlineStrokeAlpha", 1 ) );
			graphics.beginFill( getStyle( "outlineFillColor", 0xFFFFFF ), getStyle( "outlineFillAlpha", 1 ) );
			graphics.drawRect( -size2, -size2, size, size );
			graphics.endFill( );
			
			blendMode = getStyle( "outlineBlendMode", BlendMode.NORMAL ); 
		}
		
		private function getStyle( name: String, _default: * ): *
		{
			if( transformTool.getStyle( name ) == null )
			{
				return _default;
			}
			
			return transformTool.getStyle( name );
		}
}


	
}